﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Data.SqlClient;


using NAVConnector;

/// <summary>
/// Help http://msdn.microsoft.com/ru-ru/library/system.web.ui.webcontrols.calendar.aspx
/// </summary>

namespace Vacation
{
    public partial class Vacation : System.Web.UI.Page
    {
        private static NAVData NAV;
        private static DataSet NAVDataInfo;
        private static int CurrYear = DateTime.Today.Year;        
        private static List<DateTime> SelectDateTime = new List<DateTime>();
        private static ListItemCollection CauseColor = new ListItemCollection();
        private static DataSet NAVDataCause, Employee;

        private void ShowCalendar()
        {
            LabelCurrYear.Text = CurrYear.ToString();

            Calendar1.TodaysDate = new DateTime(CurrYear, 1, 1);
            Calendar2.TodaysDate = new DateTime(CurrYear, 2, 1);
            Calendar3.TodaysDate = new DateTime(CurrYear, 3, 1);
            Calendar4.TodaysDate = new DateTime(CurrYear, 4, 1);
            Calendar5.TodaysDate = new DateTime(CurrYear, 5, 1);
            Calendar6.TodaysDate = new DateTime(CurrYear, 6, 1);
            Calendar7.TodaysDate = new DateTime(CurrYear, 7, 1);
            Calendar8.TodaysDate = new DateTime(CurrYear, 8, 1);
            Calendar9.TodaysDate = new DateTime(CurrYear, 9, 1);
            Calendar10.TodaysDate = new DateTime(CurrYear, 10, 1);
            Calendar11.TodaysDate = new DateTime(CurrYear, 11, 1);
            Calendar12.TodaysDate = new DateTime(CurrYear, 12, 1);

            Calendar1.TodayDayStyle.BackColor = Calendar1.DayStyle.BackColor;
            Calendar2.TodayDayStyle.BackColor = Calendar2.DayStyle.BackColor;
            Calendar3.TodayDayStyle.BackColor = Calendar3.DayStyle.BackColor;
            Calendar4.TodayDayStyle.BackColor = Calendar4.DayStyle.BackColor;
            Calendar5.TodayDayStyle.BackColor = Calendar5.DayStyle.BackColor;
            Calendar6.TodayDayStyle.BackColor = Calendar6.DayStyle.BackColor;
            Calendar7.TodayDayStyle.BackColor = Calendar7.DayStyle.BackColor;
            Calendar8.TodayDayStyle.BackColor = Calendar8.DayStyle.BackColor;
            Calendar9.TodayDayStyle.BackColor = Calendar9.DayStyle.BackColor;
            Calendar10.TodayDayStyle.BackColor = Calendar10.DayStyle.BackColor;
            Calendar11.TodayDayStyle.BackColor = Calendar11.DayStyle.BackColor;
            Calendar12.TodayDayStyle.BackColor = Calendar12.DayStyle.BackColor;

            Calendar1.SelectedDate = DateTime.MinValue;
            Calendar2.SelectedDate = DateTime.MinValue;
            Calendar3.SelectedDate = DateTime.MinValue;
            Calendar4.SelectedDate = DateTime.MinValue;
            Calendar5.SelectedDate = DateTime.MinValue;
            Calendar6.SelectedDate = DateTime.MinValue;
            Calendar7.SelectedDate = DateTime.MinValue;
            Calendar8.SelectedDate = DateTime.MinValue;
            Calendar9.SelectedDate = DateTime.MinValue;
            Calendar10.SelectedDate = DateTime.MinValue;
            Calendar11.SelectedDate = DateTime.MinValue;
            Calendar12.SelectedDate = DateTime.MinValue;
        }


        private void FirstLoadNAVData()
        {
            // connect to NAV
            NAV = new NAVData(User.Identity.Name.ToString());

            // load cause data
            NAVDataCause = NAV.GetTable(5206,String.Empty); // get from "Cause of Absence" table all data
        }
        
        private void NextLoadNAVData()        
        {
            // clear calendar control
            ShowCalendar();

            // clear a selected dates
            SelectDateTime.Clear();

            // load absence data
            NAVDataInfo = NAV.hr_get_absence(CurrYear); 
                        
            // load some employment data
            Employee = NAV.hr_employee(CurrYear);
            LabelEmployee.Text = String.Format("User Code - [{0}]", Employee.Tables[0].Rows[0]["No."].ToString());            
            LabelTotalAbsence.Text = Employee.Tables[0].Rows[0]["Total Absence (Base)"].ToString();
            DateTime dt = new DateTime(CurrYear, 12, 31);
            LabelTotalDays.Text = dt.Date.DayOfYear.ToString();

            // load cause to page
            DropDownListType.Items.Clear();
            foreach (DataRow theRow in NAVDataCause.Tables[0].Rows)
            {
                ListItem item = new ListItem(theRow["Description"].ToString(), theRow["Code"].ToString());
                DropDownListType.Items.Add(item);

                ListItem item2 = new ListItem(theRow["Code"].ToString(), theRow["Color"].ToString());
                CauseColor.Add(item2);

                // create info about color
                TableRow row = new TableRow();
                TableCell cell1 = new TableCell();
                cell1.Text = theRow["Description"].ToString();
                row.Cells.Add(cell1);
                TableCell cell2 = new TableCell();
                cell2.Text = "&nbsp;&nbsp;&nbsp;";
                cell2.BackColor = System.Drawing.Color.FromName(theRow["Color"].ToString());
                row.Cells.Add(cell2);
                TableDesignation.Rows.Add(row);
            }

        }


        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                FirstLoadNAVData();
                NextLoadNAVData();
            }
            else
            {
            }

        }

        protected void ButtonPred_Click(object sender, EventArgs e)
        {
            CurrYear--;
            NextLoadNAVData();
        }

        protected void ButtonNext_Click(object sender, EventArgs e)
        {
            CurrYear++;
            NextLoadNAVData();
        }

        protected void Calendar_DayRender(object sender, DayRenderEventArgs e)
        {
            DateTime FromDay, ToDay;

            Style todayStyle = new Style();
            todayStyle.BorderColor = System.Drawing.Color.Red;
            todayStyle.BorderWidth = 3;

            Style selectStyle = new Style();
            selectStyle.BorderColor = System.Drawing.Color.Navy;
            selectStyle.BorderWidth = 3;

            try
            {
                if (NAVDataInfo.Tables.Count > 0)
                {
                    foreach (DataRow theRow in NAVDataInfo.Tables[0].Rows)
                    {
                        FromDay = ToDay = NAVData.NAVConvertDT(theRow["From Date"].ToString());
                        if (!String.IsNullOrEmpty(theRow["To Date"].ToString()))
                        {
                            ToDay = NAVData.NAVConvertDT(theRow["To Date"].ToString());
                        }

                        if ((e.Day.Date >= FromDay) && (e.Day.Date <= ToDay))
                        {
                            Style postStyle = new Style();                            
                            postStyle.BackColor =
                              System.Drawing.Color.FromName(CauseColor.FindByText(theRow["Cause of Absence Code"].ToString()).Value); 
                            e.Cell.ApplyStyle(postStyle);
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                Page.Title = ex.Message.ToString();
            }

            if (e.Day.Date == DateTime.Today)
            {
                e.Cell.ApplyStyle(todayStyle);
            }


            foreach (DateTime dt in SelectDateTime)
            {
                if (e.Day.Date == dt.Date)
                {
                    e.Cell.ApplyStyle(selectStyle);
                }
            }
        }

        protected void Calendar_SelectionChanged(object sender, EventArgs e)
        {
            SelectDateTime.Add((sender as Calendar).SelectedDate);
        }

        protected void ButtonApply_Click(object sender, EventArgs e)
        {
            NAVData NAV = new NAVData(User.Identity.Name.ToString());
            foreach (DateTime dt in SelectDateTime)
            {
                NAV.hr_post_absence(dt, DropDownListType.SelectedItem.Value); 
            }
            
            NextLoadNAVData();
        }

        protected void ButtonClear_Click(object sender, EventArgs e)
        {           
            NextLoadNAVData();
        }

        protected void ButtonDelete_Click(object sender, EventArgs e)
        {
            NAVData NAV = new NAVData(User.Identity.Name.ToString());
            foreach (DateTime dt in SelectDateTime)
            {
                NAV.hr_delete_absence(dt);
            }
            
            NextLoadNAVData();
        }
    }
}
